Generic Image Library: image< Pixel, IsPlanar, Alloc > Class Template Reference

###  | #  |

Public Types | Public Member Functions | Public Attributes | List of all members
image< Pixel, IsPlanar, Alloc > Class Template Reference
Image » Models | PixelBased » Models

container interface over image view. Models ImageConcept, PixelBasedConcept More...

`#include <image.hpp>`

## Public Types
using | allocator_type = typename std::allocator_traits<Alloc>::template rebind_alloc<unsigned char>
using | view_t = typename view_type_from_pixel<Pixel, IsPlanar>::type
using | const_view_t = typename view_t::const_t
using | point_t = typename view_t::point_t
using | coord_t = typename view_t::coord_t
using | value_type = typename view_t::value_type
using | x_coord_t = coord_t
using | y_coord_t = coord_t

## Public Member Functions
point_t const & | dimensions () const
x_coord_t | width () const
y_coord_t | height () const
| image (std::size_t alignment=0, const Alloc alloc_in=Alloc())
| image (point_t const &dimensions, std::size_t alignment=0, const Alloc alloc_in=Alloc())
| image (x_coord_t width, y_coord_t height, std::size_t alignment=0, const Alloc alloc_in=Alloc())
| image (point_t const &dimensions, const Pixel &p_in, std::size_t alignment=0, const Alloc alloc_in=Alloc())
| image (x_coord_t width, y_coord_t height, const Pixel &p_in, std::size_t alignment=0, const Alloc alloc_in=Alloc())
| image (const image &img)
template<typename P2 , bool IP2, typename Alloc2 >
| image (const image< P2, IP2, Alloc2 > &img)
template<typename Loc , typename std::enable_if< pixels_are_compatible< typename Loc::value_type, Pixel >::value, int >::type = 0>
| image (const image_view< Loc > &view, std::size_t alignment=0, const Alloc alloc_in=Alloc())
| image (image &&img)
image & | operator= (const image &img)
template<typename Img >
image & | operator= (const Img &img)
image & | operator= (image &&img)
Alloc & | allocator ()
Alloc const & | allocator () const
void | swap (image &img)
void | recreate (point_t const &dims, std::size_t alignment=0)
void | recreate (x_coord_t width, y_coord_t height, std::size_t alignment=0)
void | recreate (point_t const &dims, const Pixel &p_in, std::size_t alignment=0)
void | recreate (x_coord_t width, y_coord_t height, const Pixel &p_in, std::size_t alignment=0)
void | recreate (point_t const &dims, std::size_t alignment, const Alloc alloc_in)
void | recreate (x_coord_t width, y_coord_t height, std::size_t alignment, const Alloc alloc_in)
void | recreate (point_t const &dims, const Pixel &p_in, std::size_t alignment, const Alloc alloc_in)
void | recreate (x_coord_t width, y_coord_t height, const Pixel &p_in, std::size_t alignment, const Alloc alloc_in)

## Public Attributes
view_t | _view

## Detailed Description

template<typename Pixel, bool IsPlanar = false, typename Alloc = std::allocator<unsigned char>>
class boost::gil::image< Pixel, IsPlanar, Alloc >

container interface over image view. Models ImageConcept, PixelBasedConcept

A 2D container whose elements are pixels. It is templated over the pixel type, a boolean indicating whether it should be planar, and an optional allocator.

Note that its element type does not have to be a pixel. `image` can be instantiated with any Regular element, in which case it models the weaker RandomAccess2DImageConcept and does not model PixelBasedConcept

When recreating an image of the same or smaller size the memory will be reused if possible.

The documentation for this class was generated from the following files:

- image.hpp
- metafunctions.hpp